<script lang="ts">
  import ColorIcon from "./ColorIcon.svelte";
  import { colors, colorScore, totalScore } from "./game";

  export let settings: GameSettings;
  export let state: GameState;

  let playerScores: [PlayerState, number][];
  $: {
    playerScores = [...state.players].map((p) => [p, totalScore(p)]);
    playerScores.sort(
      ([_playerA, totalA], [_playerB, totalB]) => totalB - totalA
    );
  }
</script>

<table>
  <thead>
    <tr>
      <th>#</th>
      <th>Player</th>
      {#each colors(settings) as color (color)}
        <th><ColorIcon {color} /></th>
      {/each}
      <th>Total</th>
      <th />
    </tr>
  </thead>
  <tbody>
    {#each playerScores as [player, total]}
      <tr>
        <td class="rank">
          {playerScores.filter(([_, t]) => t > total).length + 1}
        </td>
        <td class="player"><gs6-user userid={player.id} /></td>
        {#each colors(settings).map((c) => colorScore(player, c)) as score}
          <td class="score">
            {#if score.normal < 0}
              &minus;{Math.abs(score.normal)}
            {:else}
              {score.normal}
            {/if}

            {#if score.bonus}
              + {score.bonus}
            {/if}
          </td>
        {/each}
        <td class="score">
          <strong>
            {#if total < 0}
              &minus;{Math.abs(total)}
            {:else}
              {total}
            {/if}
          </strong>
        </td>
      </tr>
    {/each}
  </tbody>
</table>

<style>
  table {
    border-spacing: 0;
  }

  th {
    border-bottom: 1px solid lightgray;
    padding: 0.5em;
  }
  td {
    padding: 0.25em;
  }
  tr:first-child > td {
    padding-top: 0.5em;
  }
  tr:last-child > td {
    padding-bottom: 0.5em;
  }
  .rank {
    text-align: center;
  }
  .player {
    padding-right: 2em;
  }
  .score {
    padding-left: 1em;
    padding-right: 1em;
    text-align: center;

    white-space: nowrap;
  }
</style>
